package at.technikumwien.movies;

import javax.inject.Inject;
import javax.jws.WebService;
import java.util.List;

// http://localhost:8080/movieservice/MoviesWebService?wsdl

@WebService(
        endpointInterface = "at.technikumwien.movies.MoviesWebService",
        serviceName = "MoviesWebService",
        portName = "MoviesWebServicePort"
)
public class MoviesWebServiceImpl implements MoviesWebService {

    @Inject
    private MoviesService moviesService;

    @Override
    public List<Movies> getAllMovies() {
        return moviesService.findAll();
    }

    @Override
    public List<Movies> getMoviesByTitle(String title) {
        return moviesService.findByTitle(title);
    }

    @Override
    public void importMovies(List<Movies> movies) {
        for (Movies movie : movies) {
            moviesService.save(movie);
        }
    }
}
